<template>
  <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="50%">
    <BasicForm @register="registerForm"> </BasicForm>
  </BasicModal>
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form/index';
  import { FormSchema } from '/@/components/Table';
  import { xiadayijian, bianjieyijian } from '/@/api/common/api';
  import { useMessage } from '/@/hooks/web/useMessage';
  // Emits声明
  const { createMessage } = useMessage();
  const emit = defineEmits(['register']);

  const AdviceFormSchema: FormSchema[] = [
    { label: '污染地块ID', field: 'wrdkid', component: 'Input', show: false },
    { label: '阶段编码', field: 'scjdbm', component: 'Input', show: false },
    { label: 'pgtype', field: 'pgtype', component: 'Input', show: false },
    {
      label: '意见',
      field: 'clyj',
      required: true,
      component: 'InputTextArea',
      componentProps: {
        rows: 3,
      },
    },
    {
      label: '文件',
      field: 'clyjfj',
      component: 'JUpload',

      componentProps: {
        fileName: '下达意见',
        showUploadList: false,
        accept: '.pdf,.zip',
        beforeUpload: (file) => {
          let isshow = false;
          const isFile = file.name.split('.')[file.name.split('.').length - 1];
          console.log(file, 'file');
          if (isFile == 'pdf' || isFile == 'zip' || isFile == 'PDF') {
            isshow = true;
          } else {
            createMessage.error('只能上传.pdf/.zip格式的文件');
            isshow = false;
          }

          // if (file.type == 'application/pdf' || file.type == 'application/x-zip-compressed') {
          //   isshow = true;
          // } else {
          //   createMessage.error('只能上传.pdf/.zip格式的文件');
          //   isshow = false;
          // }
          return isshow;
        },
      },
    },
  ];
  //表单配置
  const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 220,
    schemas: AdviceFormSchema,
    showActionButtonGroup: false,
  });
  //设置标题
  const title = ref('下达意见');
  //表单赋值
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    title.value = data.record.title;
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });

    //表单赋值
    await setFieldsValue({
      ...data.record,
    });
  });

  //表单提交事件
  async function handleSubmit() {
    try {
      let values = await validate();
      setModalProps({ confirmLoading: true });
      //提交表单
      if (title.value == '下达意见') {
        await xiadayijian(values);
      } else if (title.value == '边界指导意见') {
        await bianjieyijian(values);
      }

      //关闭弹窗
      closeModal();
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>

<style lang="less" scoped></style>
